// ColorWash.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "colorwash.h"
#include "Interface.h"
#include <math.h>
#include "MainData.h"
#include "Settings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//**************** Path to the <SrcDir>
CString m_sPath;
//*************************************
//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CColorWashApp

#include "MainData.h"

// create the MainData object using VTable
extern "C" __declspec(dllexport) CMainData* CreateObject()
{
	
	return new CMainData();
}
extern "C" __declspec(dllexport) void Interface_cm()
{
//CMainData ddat;		
//ddat CreateObject()

//ddat.Default;
//ddat.Interface;

	CMainData::Interface;
}
extern "C" __declspec(dllexport) char* GetShortInfo()
{
	return "ColorWash 1.0";
}

extern "C" __declspec(dllexport) char* GetInfo()
{
	return "This is just simple plug-in for color wash.";
}

extern "C" __declspec(dllexport) char* Copyright()
{
	return "(c) Oscar 1999";
}


extern "C" __declspec(dllexport) void SetPath(char* path)
{
	CString str(path);
	m_sPath = str;
}

// 0- standard OO interface
// 1- Plugin without interface.
// 2- other

extern "C" __declspec(dllexport) int GetType()
{
	return 0;
}

//Public Settings
// some of the plugins can have public dialog
// called from script

extern "C" __declspec(dllexport) void Settings()
{

	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CSettings dlg;

	dlg.DoModal();
}


// internal stuff - to get path to <SrcDir>
// see MainData
CString GetPath()
{
	return m_sPath;
}



BEGIN_MESSAGE_MAP(CColorWashApp, CWinApp)
	//{{AFX_MSG_MAP(CColorWashApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorWashApp construction

CColorWashApp::CColorWashApp()
{

}

/////////////////////////////////////////////////////////////////////////////
// The one and only CColorWashApp object

CColorWashApp theApp;

